/*
 * Implementation of class FullVector
 *
 * $Date: 2004/05/20 11:06:11 $
 * $Revision: 1.3 $
 *
 */

#include "WImage/debug.h"
#include "WImage/miscdefs.h"
#include "WImage/FullVector.hh"
#include <iostream>
#include <stdexcept>

#ifndef __WATCOMC__
using namespace std;
#endif

void 
FullVector::go (int root)
{
  ImageVector::go (root);
  if (this->m_vroot > this->m_xysize)
    {
      throw invalid_argument ("go: root cannot be greater than size.");
    }
}

coeff 
FullVector::at (int pos) 
{ 
  return m_array->array () [this->m_vroot + pos];
}

void 
FullVector::to (int pos, coeff val) 
{ 
  m_array->array () [this->m_vroot + pos] = val;
}

int
FullVector::size (void)
{ 
  return m_array->size () - this->m_vroot; 
} 

void 
FullVector::update (void) 
{ 
  ImageVector::update ();
  m_xysize = m_xsize * m_ysize;
  if (m_vroot > m_xysize)
    {
      m_vroot = m_xysize;
    }
}

