/*
 * Implementation of class ImageVector
 *
 * $Date: 2004/05/20 15:07:54 $
 * $Revision: 1.2 $
 *
 */

#include "WImage/debug.h"
#include "WImage/miscdefs.h"
#include "WImage/ImageVector.hh"
#include <iostream>
#include <stdexcept>

#ifndef __WATCOMC__
using namespace std;
#endif

ImageVector::ImageVector (ImageArray<coeff> *ar) : ReferenceVector ()
{
  this->m_array = ar;
  this->update ();
  this->go (0);
}

void
ImageVector::go (int root)
{
  if (root < 0)
    {
      throw invalid_argument ("go: root cannot have negative value.");
    }
  this->m_vroot = root;
}

bool
ImageVector::sanity (void)
{
  return (m_array->cols () == this->m_xsize 
          && m_array->rows () == this->m_ysize);
}

void
ImageVector::update (void)
{
  this->m_xsize = m_array->cols ();
  this->m_ysize = m_array->rows ();
}

