/*
 * Implementation of class PixmapFile
 *
 * $Date: 2003/08/26 10:48:37 $
 * $Revision: 1.3 $
 *
 */

#include "WImage/PixmapFile.hh"
#include "WImage/ImageArray.hh"
#include "WImage/debug.h"
#include <stdexcept>

#ifndef __WATCOMC__
using namespace std;
#endif

PixmapFile::PixmapFile (char const * name, Image *images[], int channels)
{
  m_fname = name;
  m_channels = channels;
  m_cmodel = cm_rgb;
  init (images);
}

PixmapFile::~PixmapFile (void)
{
  delete m_images;
}

void
PixmapFile::init (Image *images[])
{
  if (m_channels > 0)
    {
      m_images = new Image* [m_channels];
      
      for (int i = 0; i < m_channels; i++)
        {
          m_images[i] = images[i];
        }
    }
  else
    {
      m_images = NULL;
    }
}

