/*
 * class PfcReader
 *
 * $Date: 2003/11/14 14:57:39 $
 * $Revision: 1.4 $
 *
 */

#ifndef PFC_READER_HH__
#define PFC_READER_HH__

#include "WImage/PixmapReader.hh"

/** @addtogroup WImage */

/**
 * @class PfcReader
 * A PFC file reader. Only PFCs version 6 are supported.
 */
class 
PfcReader: public PixmapReader
{
public:
  /** Constructor. Only calls the mother class' constructor to initialize
   * the {\em ImageArray} reference. 
   * @param name
   * the file name
   * @param images
   * the array of greyscale images for the values 
   * @param colors
   * the number of colors */
  PfcReader (char const * name, Image *images[], int colors = 3)
    : PixmapReader (name, images, colors) { }

protected:
  /** Read the PFC file format. This does the actual work of reading and
   * parsing the image file. It gets called by the {\em read ()} method.
   * @return 
   * 0 if successful, -1 on read error, -2 on file format error. */
  virtual int readfmt (void);

}; /* class PfcReader */

#endif /* PFC_READER_HH__ */
