/*
 * class PfcWriter
 *
 * $Date: 2003/11/14 14:57:40 $
 * $Revision: 1.4 $
 *
 */

#ifndef PFC_WRITER_HH__
#define PFC_WRITER_HH__

#include "WImage/PixmapWriter.hh"

/** @addtogroup WImage */
/**
 * @class PfcWriter
 * A PFC image file writer. Dimensions are known from the {\em Image}
 * object. Only PFC version 6 is supported.
 */
class 
PfcWriter: public PixmapWriter
{
public:
  
  /** Constructor. Only calls the mother class' constructor to initialize
   * the {\em ImageArray} reference and set the offset if necessary. 
   * @param name
   * the file name
   * @param images
   * the array of greyscale images for the values  
   * @param colors
   * the number of colors 
   * @param cmodel
   * the color model */
  PfcWriter (char const *name, Image *images[], int colors = 3, 
             clrmodel cmodel = cm_rgb)
    : PixmapWriter (name, images, colors) { colormodel (cmodel); }

protected: 
  /** Write a PFC image file. This is the method that does the actual
   * work. It will be called by the {\em write ()} method.
   * @return 
   * 0 if successful, -1 on write error. */
  virtual int writefmt (void);
  
}; /* class PfcWriter */

#endif /* PFC_WRITER_HH__ */
