/*
 * class PgmReader
 *
 * $Date: 2003/11/14 14:57:40 $
 * $Revision: 1.5 $
 *
 */

#ifndef PGM_READER_HH__
#define PGM_READER_HH__

#include "WImage/GreymapReader.hh"

/** @addtogroup WImage */

/**
 * @class PgmReader
 * A PGM file reader. Only PGMs version 5 are supported.
 */
class 
PgmReader: public GreymapReader
{
public:
  /** Constructor. Only calls the mother class' constructor to initialize
   * the {\em ImageArray} reference. 
   * @param name
   * the file name
   * @param data
   * the reference to the {\em ImageArray} object */
  PgmReader (char const * name, ImageArray<coeff> &data)
    : GreymapReader (name, data) {}

protected:
  /** Read the PGM file format. This does the actual work of reading and
   * parsing the image file. It gets called by the {\em read ()} method.
   * @return 
   * 0 if successful, -1 on read error, -2 on file format error. */
  virtual int readfmt (void);

}; /* class PgmReader */

#endif /* PGM_READER_HH__ */
