/*
 * class PgmWriter
 *
 * $Date: 2003/11/14 14:57:40 $
 * $Revision: 1.5 $
 *
 */

#ifndef PGM_WRITER_HH__
#define PGM_WRITER_HH__

#include "WImage/GreymapWriter.hh"

/** @addtogroup WImage */

/**
 * @class PgmWriter
 * A PGM image file writer. Dimensions are known from the {\em ImageArray}
 * object. Only PGM version 5 is supported.
 */
class 
PgmWriter: public GreymapWriter
{
public:
  
  /** Constructor. Only calls the mother class' constructor to initialize
   * the {\em ImageArray} reference and set the offset if necessary. 
   * @param name
   * the file name
   * @param data
   * the reference to the {\em ImageArray} object */
  PgmWriter (char const *name, ImageArray<coeff> &data)
    : GreymapWriter (name, data) {}

protected: 
  /** Write a PGM image file. This is the method that does the actual
   * work. It will be called by the {\em write ()} method.
   * @return 
   * 0 if successful, -1 on write error. */
  virtual int writefmt (void);
  
}; /* class PgmWriter */

#endif /* PGM_WRITER_HH__ */
