/*
 * class PpmWriter
 *
 * $Date: 2003/11/14 14:57:40 $
 * $Revision: 1.5 $
 *
 */

#ifndef PPM_WRITER_HH__
#define PPM_WRITER_HH__

#include "WImage/PixmapWriter.hh"

/** @addtogroup WImage */

/**
 * @class PpmWriter
 * A PPM image file writer. Dimensions are known from the {\em Image}
 * object. Only PPM version 6 is supported.
 */
class 
PpmWriter: public PixmapWriter
{
public:
  
  /** Constructor. Only calls the mother class' constructor to initialize
   * the {\em ImageArray} reference and set the offset if necessary. 
   * @param name
   * the file name
   * @param images
   * the array of greyscale images for the values  */
  PpmWriter (char const *name, Image *images[])
    : PixmapWriter (name, images, 3) {}

protected: 
  /** Write a PPM image file. This is the method that does the actual
   * work. It will be called by the {\em write ()} method.
   * @return 
   * 0 if successful, -1 on write error. */
  virtual int writefmt (void);
}; /* class PpmWriter */

#endif /* PPM_WRITER_HH__ */
