/*
 * Toolbox for image operations (class-independent)
 *
 * $Date: 2003/12/11 15:06:39 $
 * $Revision: 1.10 $
 *
 */

#ifndef TOOLS_H__
#define TOOLS_H__
/** @addtogroup WImage */

#include "WImage/miscdefs.h"

/** Convert a coeff value to a pixel.
 * @param c
 * the coefficient
 * @return the pixel value */
pixel tools_coeff2pixel (coeff c);

/** Return true if two double values are equal
 * @param d1 the first value
 * @param d2 the second value
 * @return true if equal */
bool tools_equals (double d1, double d2);

/** Calculate an area from a string split to two characters
 * @param a1 the first character
 * @param a2 the second character
 * @param result the result
 * @return true if a valid area name was passed, else false */
bool tools_areaFromString (char a1, char a2, area &result);

/** Calculate an area from a string 
 * @param a the string containing the area name
 * @param result the result
 * @return true if a valid area name was passed, else false */
bool tools_areaFromString (char *a, area &result);

/** Find out whether a number is a power of two.
 * @param value the value to test
 * @param power (returned value) the power of two if the result is true.
 * @return true if value is a power of two. */
bool tools_powerOfTwo (int value, int &power);

/** Calculate a vector's start index so that a given position is in its center.
 * @param pos the position
 * @param length the vector's length
 * @return the start index */
int tools_startFromCenter (int pos, int length);

#endif /* TOOLS_H__*/
