/*
 * Test program for the class FileName
 *
 * $Date: 2003/08/26 10:48:43 $
 * $Revision: 1.3 $
 *
 */

#ifdef NDEBUG
#undef NDEBUG
#endif /* NDEBUG */

#include "WImage/FileName.hh"
#include <assert.h>
#include <iostream>

#ifndef __WATCOMC__
using namespace std;
#endif

int
main (void)
{
  cout << "Testing class FileName...\n";

  FileName *name = new FileName ("/usr/src/x.c");
  cout << name->dir () << name->base () << name->ext () << endl;
  assert (strcmp (name->dir (), "/usr/src/") == 0);
  assert (strcmp (name->base (), "x") == 0);
  assert (strcmp (name->ext (), ".c") == 0);
  cout << (int)name->guess () << endl;
  assert (name->guess () == fn_unknown);
  assert (name->dos () == false);
  name->toext (".pgM");
  assert (name->guess () == fn_pgm);
  name->toext (".RAW");
  assert (name->guess () == fn_raw);
#ifdef PFI
  name->toext (".PfI");
  assert (name->guess () == fn_pfi);
#endif
  delete name;
  
  name = new FileName ("e:\\usr\\src/x.c");
  cout << name->dir () << name->base () << name->ext () << endl;
  assert (strcmp (name->dir (), "e:\\usr\\src/") == 0);
  assert (strcmp (name->base (), "x") == 0);
  assert (strcmp (name->ext (), ".c") == 0);
  assert (name->guess () == fn_unknown);
  assert (name->dos () == true);
  name->toext (".");
  cout << name->dir () << name->base () << name->ext () << endl;
  assert (name->guess () == fn_unknown);
  name->toext ("");
  cout << name->dir () << name->base () << name->ext () << endl;
  assert (name->guess () == fn_unknown);
  delete name;

  cout << "Test of class FileName completed successfully.\n";
  return 0;
}
