/*
 * Toolbox for image operations (class-independent)
 *
 * $Date: 2003/12/11 15:06:39 $
 * $Revision: 1.7 $
 *
 */

#include "WImage/tools.h"
#include <float.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

pixel
tools_coeff2pixel (coeff c)
{
  c = (c < 0? 0: c);
  return (pixel)(c + 0.5);
}

bool
tools_equals (double d1, double d2)
{
  return (fabs (d1 - d2) < DBL_EPSILON);
}

bool
tools_areaFromString (char a1, char a2, area &result)
{
  char buf[3];
  buf[0] = a1;
  buf[1] = a2;
  buf[2] = '\0';
  return tools_areaFromString (buf, result);
}

bool
tools_areaFromString (char *a, area &result)
{
  if (strlen (a) != 2)
    {
      return false;
    }
  char buf[3];
  
  for (int i = 0; i < (int)strlen (a); i++)
    {
      buf[i] = toupper (a[i]);
    }
  buf[strlen (a)] = '\0';
  if (strcmp (buf, "LL") == 0)
    {
      result = LL;
    }
  else if (strcmp (buf, "HL") == 0)
    {
      result = HL;
    }
  else if (strcmp (buf, "LH") == 0)
    {
      result = LH;
    }
  else if (strcmp (buf, "HH") == 0)
    {
      result = HH;
    }
  else
    {
      return false;
    }
  return true;
}

bool
tools_powerOfTwo (int value, int &power)
{
  int i;
  
  for (i = 1; i < value; power++, i = MUL2 (i))
    {
    }

  return (i == value);
}

int
tools_startFromCenter (int pos, int length)
{
  return pos - (length + 1) / 2 + 1;
}

